function [w,b,cost,w_buff,b_buff] = logistic_batch_train(x,y,tol,max_iter)
n = size(x,1);
N = size(x,2);
w = zeros(n,1);
b = zeros(1,1);
cost = logistic_cost(x,y,w,b);
count = 1;
k=1;
lambda = 0.00005;
step = 0.001;
while 1
    w_buff(:,k) = w;
    b_buff(k) = b;
    k = k+1;
%% compute gradient
    partial_w = zeros(n,1);
    partial_b = 0;
    for i=1:N
        a = 1/exp(w'*x(:,i)+b);
        partial_w = partial_w + (1/(a+1)-y(i))*x(:,i)/N + lambda*w/N;
        partial_b = partial_b + (1/(a+1)-y(i))/N;
    end
    old_cost = logistic_cost(x,y,w,b);
    w1 = w - step*partial_w;
    b1 = b - step*partial_b;
    new_cost = logistic_cost(x,y,w1,b1);
    cost = [cost,new_cost];
    w = w1;
    b = b1;
    if new_cost < tol
        fprintf('converged after %d iterates!',count);
        break;
    end
    if  count > max_iter
       fprintf('stoped after %d iterates',count);
        break;
    end
    count = count + 1;       
end