function [w,b,cost,w_buff,b_buff] = logistic_stochastic_train(x,y,tol,max_iter)
n = size(x,1);
N = size(x,2);
k=1;
w = zeros(n,1);
b = zeros(1,1);
cost = logistic_cost(x,y,w,b);
count = 1;
epoch = 4000;
step = 0.001;
accuracy = [];
lambda = 0.00005;
%% compute gradient
for ep = 1:epoch
    w_buff(:,k) = w;
    b_buff(k) = b;
    partial_w = zeros(n,1);
    partial_b = 0;
    for i=1:1
        k = k+1;
        a = 1/exp(w'*x(:,i)+b);
        partial_w = (1/(a+1)-y(i))*x(:,i) + lambda*w;
        partial_b = (1/(a+1)-y(i));
        old_cost = logistic_cost(x,y,w,b);
        w1 = w - step*partial_w;
        b1 = b - step*partial_b;
        new_cost = logistic_cost(x,y,w1,b1);
        cost = [cost,new_cost];
        w = w1;
        b = b1;
        count = count + 1;
        if count > max_iter
            break;
        end
    end
    if count > max_iter
        break;
    end
    rndp = randperm(N);
    x = x(:,rndp);
    y = y(rndp);
end